Attribute VB_Name = "Module1"
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const LB_SETHORIZONTALEXTENT = &H194

' Set the list box's horizontal extent so it
' can display its longest entry. This routine
' assumes the form is using the same font as
' the list box.
'
'
' Changed to public subroutine in a module
' by Richard Wilkinson - July 2007.
'
' Called as in:
'       SetListboxScrollBar List1
' Where List1 is the listbox to receive the scrollBar
Public Sub SetListboxScrollbar(ByVal lst As ListBox)
Dim i As Integer
Dim new_len As Long
Dim max_len As Long

    For i = 0 To lst.ListCount - 1
        new_len = 10 + lst.Parent.ScaleX( _
            lst.Parent.TextWidth(lst.List(i)), _
            lst.Parent.ScaleMode, vbPixels)
        If max_len < new_len Then max_len = new_len
    Next i

    SendMessage lst.hwnd, _
        LB_SETHORIZONTALEXTENT, _
        max_len, 0
End Sub

